#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  RoyalBlue
#property indicator_color2  Red
extern string TimeFrame       = "Current time frame";
extern int    arrowSize       = 2; 
extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";
double CrossUp[];
double CrossDn[];
double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[];
double trend[];
string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

int init()
{

   IndicatorBuffers(7);  
   SetIndexBuffer(0,CrossUp); SetIndexStyle(0, DRAW_ARROW,0,arrowSize); SetIndexArrow(0, 241);
   SetIndexBuffer(1,CrossDn); SetIndexStyle(1, DRAW_ARROW,0,arrowSize); SetIndexArrow(1, 242);
   SetIndexBuffer(2,Buffer1); 
   SetIndexBuffer(3,Buffer2); 
   SetIndexBuffer(4,Buffer3); 
   SetIndexBuffer(5,Buffer4);
   SetIndexBuffer(6,trend);

         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
         
   IndicatorShortName(timeFrameToString(timeFrame)+  " X_Arrows_X ");
return(0);
}

int deinit()  
{
   
return(0);  
}

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { CrossUp[0] = limit+1; return(0); }
   
   if (calculateValue || timeFrame == Period())
   {

     for (i=limit; i >= 0; i--)
     {
          
         double haClose = (Open[i] + High[i] + Low[i] + Close[i])/4;
         double haOpen  = (Buffer3[i+1] + Buffer4[i+1])/2;
         double haHigh  = MathMax(High[i],MathMax(haOpen,haClose));
         double haLow   = MathMin(Low[i], MathMin(haOpen,haClose));
          
         if (haOpen < haClose) { Buffer1[i] = haLow;  Buffer2[i] = haHigh; } 
         else                  { Buffer1[i] = haHigh; Buffer2[i] = haLow;  } 
                                 Buffer3[i] = haOpen;
                                 Buffer4[i] = haClose;
                                  
          
         trend[i] = trend[i+1];
         if (Buffer3[i] < Buffer4[i]) trend[i] =  1;
         if (Buffer3[i] > Buffer4[i]) trend[i] = -1;  
      
         CrossUp[i] = EMPTY_VALUE;
         CrossDn[i] = EMPTY_VALUE;
         if (trend[i]!= trend[i+1])
         if (trend[i] == 1)
               CrossUp[i] =  Low[i] - iATR(NULL,0,20,i)/2.0;
         else  CrossDn[i] = High[i] + iATR(NULL,0,20,i)/2.0;
      }
      manageAlerts();
      return(0);
      }
 
      limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      for (i=limit;i>=0; i--)
      {
         int y = iBarShift(NULL,timeFrame,Time[i]);
            trend[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",6,y);
            CrossUp[i] = EMPTY_VALUE;
            CrossDn[i] = EMPTY_VALUE;
            if (trend[i]!= trend[i+1])
            if (trend[i] == 1)
                  CrossUp[i] = Low[i]  - iATR(NULL,0,20,i)/2.0;
            else  CrossDn[i] = High[i] + iATR(NULL,0,20,i)/2.0; 
      }
  manageAlerts();
return(0);
}

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"buy");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
}   

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" X_Arrow_X ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," X_Arrow_X "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}


